<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>task48.10</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="./plugins/fontawesome-free/css/all.min.css">
  <!-- daterange picker -->
  <link rel="stylesheet" href="./plugins/daterangepicker/daterangepicker.css">
  <!-- Bootstrap Color Picker -->
  <link rel="stylesheet" href="./plugins/bootstrap-colorpicker/css/bootstrap-colorpicker.min.css">
  <!-- Tempusdominus Bootstrap 4 -->
  <link rel="stylesheet" href="./plugins/tempusdominus-bootstrap-4/css/tempusdominus-bootstrap-4.min.css">
  <!-- font-awesome -->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="./dist/css/adminlte.min.css">
  <!-- Select2 -->
  <link rel="stylesheet" href="./plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="./plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
  <!-- data table -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.3/css/dataTables.bootstrap4.min.css">
</head>

<body class="hold-transition sidebar-mini">
  <!-- Site wrapper -->
  <div class="wrapper">
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="./index3.html" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <!-- Navbar Search -->
        <li class="nav-item">
          <a class="nav-link" data-widget="navbar-search" href="#" role="button">
            <i class="fas fa-search"></i>
          </a>
          <div class="navbar-search-block">
            <form class="form-inline">
              <div class="input-group input-group-sm">
                <input class="form-control form-control-navbar" type="search" placeholder="Search" aria-label="Search">
                <div class="input-group-append">
                  <button class="btn btn-navbar" type="submit">
                    <i class="fas fa-search"></i>
                  </button>
                  <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                    <i class="fas fa-times"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
        </li>

        <!-- Messages Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-comments"></i>
            <span class="badge badge-danger navbar-badge">3</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="./dist/img/user1-128x128.jpg" alt="User Avatar" class="img-size-50 mr-3 img-circle">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Brad Diesel
                    <span class="float-right text-sm text-danger"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">Call me whenever you can...</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="./dist/img/user8-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    John Pierce
                    <span class="float-right text-sm text-muted"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">I got your message bro</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="./dist/img/user3-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3">
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Nora Silvester
                    <span class="float-right text-sm text-warning"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">The subject goes here</p>
                  <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Messages</a>
          </div>
        </li>
        <!-- Notifications Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-bell"></i>
            <span class="badge badge-warning navbar-badge">15</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <span class="dropdown-item dropdown-header">15 Notifications</span>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-envelope mr-2"></i> 4 new messages
              <span class="float-right text-muted text-sm">3 mins</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-users mr-2"></i> 8 friend requests
              <span class="float-right text-muted text-sm">12 hours</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-file mr-2"></i> 3 new reports
              <span class="float-right text-muted text-sm">2 days</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Notifications</a>
          </div>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="fullscreen" href="#" role="button">
            <i class="fas fa-expand-arrows-alt"></i>
          </a>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="control-sidebar" data-slide="true" href="#" role="button">
            <i class="fas fa-th-large"></i>
          </a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="./index3.html" class="brand-link">
        <img src="./dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">AdminLTE 3</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="./dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">Alexander Pierce</a>
          </div>
        </div>

        <!-- SidebarSearch Form -->
        <div class="form-inline">
          <div class="input-group" data-widget="sidebar-search">
            <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
            <div class="input-group-append">
              <button class="btn btn-sidebar">
                <i class="fas fa-search fa-fw"></i>
              </button>
            </div>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item">
              <a href="#" class="nav-link active">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Dashboard
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="./chartJS.html" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>LỊCH SỬ HỌC TẬP</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="./select-multiple.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>select2</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="./range-selectpicker.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Datetine Picker</p>
                  </a>
                </li>

              </ul>
        </nav>
        <!-- /.sidebar-menu  -->
      </div>
      <!-- /.sidebar -->
    </aside>
    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">

      <!-- Main content -->
      <section class="content">
        <!-- Main content -->
        <!-- Main content -->
        <!-- Main content -->
        <div class="comtainer-fluid">
          <h1 class="text-center" style="background-color: white;">F200- LỊCH SỬ HỌC TẬP</h1>
        </div>
        <div class="comtainer-fluid">
          <div class="container">
            <div class="row">
              <div class="col-sm-12">
                <label for="">Lọc Bảng Điểm:</label>
              </div>
            </div>
            <div class="row">
              <div class="col-sm-2">
                <label for="">Sinh viên</label>
              </div>
              <div class="col-sm-3">
                <select name="" class="form-control  select2 select-sinh-vien" multiple="multiple"
                  data-placeholder="Select a State" style="width: 100%;">
                  <option value="0">---Chọn Sinh Viên---</option>
                </select>
              </div>
              <div class="col-sm-2">
                <label for="">Môn học</label>
              </div>
              <div class="col-sm-3">
                <select class="form-control select2 select-mon-hoc" multiple="multiple"
                  data-placeholder="Select a State" style="width: 100%;">
                  <option value="0">---Chọn Môn Học---</option>
                </select>
              </div>
              <div class="col-sm-2">
                <button class=" btn btn-success btn-loc-du-lieu">Lọc Dữ Liệu</button>
              </div>
            </div>

            <div class="row">
              <div class="col-sm-2">
                <button id="btn-them-diem" class=" btn btn-success ">
                  <i class="fa-solid fa-plus"></i> Thêm
                </button>
              </div>
            </div>
          </div>
        </div>
        <!-- data table -->
        <div class="comtainer-fluid mt-5">
          <table id="table-lich-su-hoc-tap" class="table table-striped table-hover table-bordered">
            <thead>
              <tr>
                <th>STT</th>
                <th>Sinh viên</th>
                <th>Môn học </th>
                <th>Điểm</th>
                <th>Ngày thi</th>
                <th>Action</th>
              </tr>
            </thead>
          </table>

        </div>
        <!-- Date -->
        <!-- Main content -->
        <!-- Main content -->
        <!-- Main content -->
      </section>
      <!-- /.content -->
    </div>
    <!-- /.content-wrapper -->

    <footer class="main-footer">
      <div class="float-right d-none d-sm-block">
        <b>Version</b> 3.2.0
      </div>
      <strong>Copyright &copy; 2014-2023 <a href="https://adminlte.io">Devcamp.io</a>.</strong> All rights reserved.
    </footer>

    <!-- Control Sidebar -->
    <aside class="control-sidebar control-sidebar-dark">
      <!-- Control sidebar content goes here -->
    </aside>
    <!-- /.control-sidebar -->
  </div>
  <!-- ./wrapper -->
  <!-- modal -->
  <!-- Update voucher modal (sửa user) -->
  <div>
    <div id="update-voucher-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Chi tiết student </h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="inp-modal-sinh-vien">Sinh viên</label>
                </div>
                <div class="col-sm-8">
                  <select name="" class="form-control select-sinh-vien" id="inp-modal-sinh-vien">
                    <option value="0">---Chọn Sinh Viên---</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="inp-modal-mon-hoc">Môn học</label>
                </div>
                <div class="col-sm-8">
                  <select name="" class="form-control select-mon-hoc" id="inp-modal-mon-hoc">
                    <option value="0">---Chọn Môn Học---</option>
                  </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="inp-modal-diem">Điểm</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="inp-modal-diem" name="vouchercodes" placeholder="Điểm" class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="inp-modal-ngay-thi">Ngày thi</label>
                </div>
                <div class="col-sm-8">
                  <div class="input-group date" id="reservationdate" data-target-input="nearest">
                    <input id="inp-modal-ngay-thi" type="text" class="form-control datetimepicker-input"
                      data-target="#reservationdate" />
                    <div class="input-group-append" data-target="#reservationdate" data-toggle="datetimepicker">
                      <div class="input-group-text"><i class="fa fa-calendar"></i></div>
                    </div>
                  </div>
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-primary" id="btn-modal-update-diem">Update student</button>
            <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Hủy bỏ</button>
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- Delete confirm modal -->
  <div>
    <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Confirm xóa user</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <label>Bạn có chắc chắn muốn xóa user này không?</label>
          </div>
          <div class="modal-footer">
            <button class="btn btn-danger" id="btn-confirm-delete-user">Xác nhận</button>
            <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ </button>
          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- insert modal (thêm user) -->
  <div>
    <div id="insert-sinh-vien-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Thêm điểm </h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="inp-modal-sinh-vien-them">Sinh viên</label>
                </div>
                <div class="col-sm-8">
                  <select name="" class="form-control select-sinh-vien" id="inp-modal-sinh-vien-them">
                    <option value="0">---Chọn Sinh Viên---</option>
                  </select>
                </div>
              </div>

              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="inp-modal-mon-hoc-them">Môn học</label>
                </div>
                <div class="col-sm-8">
                  <select name="" class="form-control select-mon-hoc" id="inp-modal-mon-hoc-them">
                    <option value="0">---Chọn Môn Học---</option>
                  </select>
                </div>
              </div>

              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="inp-modal-diem-them">Điểm</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="inp-modal-diem-them" name="vouchercodes" placeholder="Điểm"
                    class="form-control">
                </div>
              </div>

              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="inp-modal-ngay-thi-them">Ngày thi</label>
                </div>
                <div class="col-sm-8">

                  <div class="input-group date" id="reservationdate-them" data-target-input="nearest">
                    <input id="inp-modal-ngay-thi-them" type="text" class="form-control datetimepicker-input"
                      data-target="#reservationdate-them" />
                    <div class="input-group-append" data-target="#reservationdate-them" data-toggle="datetimepicker">
                      <div class="input-group-text"><i class="fa fa-calendar"></i></div>
                    </div>
                  </div>
                </div>
              </div>


            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-primary" id="btn-modal-insert-diem">Thêm điểm</button>
            <button class="btn btn-secondary" id="btn-update-cancel-them" data-dismiss="modal">Hủy bỏ</button>

          </div>
        </div>
      </div>
    </div>
  </div>

  <!-- .modal -->

  <!-- jQuery -->
  <script src="./plugins/jquery/jquery.min.js"></script>
  <!-- Bootstrap 4 -->
  <script src="./plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!-- Select2 -->
  <script src="./plugins/select2/js/select2.full.min.js"></script>
  <!-- InputMask -->
  <script src="./plugins/moment/moment.min.js"></script>
  <script src="./plugins/inputmask/jquery.inputmask.min.js"></script>
  <!-- date-range-picker -->
  <script src="./plugins/daterangepicker/daterangepicker.js"></script>
  <!-- bootstrap color picker -->
  <script src="./plugins/bootstrap-colorpicker/js/bootstrap-colorpicker.min.js"></script>
  <!-- Tempusdominus Bootstrap 4 -->
  <script src="./plugins/tempusdominus-bootstrap-4/js/tempusdominus-bootstrap-4.min.js"></script>
  <!-- AdminLTE App -->
  <script src="./dist/js/adminlte.min.js"></script>
  <!-- AdminLTE for demo purposes -->
  <script src="./dist/js/demo.js"></script>
  <!-- data table -->
  <script src="https://cdn.datatables.net/1.13.3/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.13.3/js/dataTables.bootstrap4.min.js"></script>

  <script>

    "use strict"

    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "https://62454a477701ec8f724fb923.mockapi.io/api/v1/";
    var gId = "";
    var gI = 0;
    var gStt = 0;  // khai báo số thứ tự ban đầu bằng 0;  tự reset sau mỗi lần đổ dữ liệu

    //khai báo biến toàn cucj cho môn học, và học sinh
    var gListMonHoc = {
      credit: "no_data",
      id: "no_data",
      subjectCode: "no_data",
      subjectName: "no_data",
    };
    var gListHocSinh = {
      email: "no_data",
      firstname: "no_data",
      id: "no_data",
      lastname: "no_data",
      studentCode: "no_data",
      studyYear: "no_data",
      username: "no_data",
    };
    // biến toàn cục cho danh sách điểm
    var gDiem = {
      country: "",
      examDate: "",
      grade: "",
      id: "",
      studentId: "",
      subjectId: "",
    }
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
      onPageLoading();
      // khai báo nút sửa 
      $("#table-lich-su-hoc-tap").on("click", ".btn-edits", onSuaClick); // khai báo nút sửa   
      $("#table-lich-su-hoc-tap").on("click", ".btn-deletes", onXoaClick); // khai báo nút xóa
      $("#btn-them-diem").on("click", onAddUserClick); // khai báo nút thêm user 
      $("#btn-modal-insert-diem").on("click", onInsertUserClick);   // nút xác nhận thêm  
      $("#btn-modal-update-diem").on("click", onModalUpdateUserClick);  // khao báo chấp nhận update user
      $("#btn-confirm-delete-user").on("click", onConfirmDeleteUserClick);     // khai báo nút xác nhận xóa
      $(".btn-loc-du-lieu").on("click", locDuLieu);     // khai báo nút xác nhận xóa
      //Date picker
      $('#reservationdate').datetimepicker({
        format: 'L'
      });
      //Date picker
      $('#reservationdate-them').datetimepicker({
        format: 'L'
      });

    });
    $(function () {
      //Initialize Select2 Elements
      $('.select2').select2()
      //Initialize Select2 Elements
      $('.select2').select2({
        theme: 'bootstrap4'
      });

    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      "use strict"
      console.log("đã load xong thẻ body ");
      // phần đổ dữ liệu cho ô select . gán dữ liệu vào biến toàn cục
      callDanhSachHocSinh();
      callDanhSachMonHoc();
      // load data table jquery nhưng chưa truyền dữ liệu 
      khoiTaoDataTable();
      //b1 bỏ qua
      //b2 bỏ qua
      //b3  call api && //b4 load data in table 
      callApiListDiem(getInsertRowTable);
    }

    // khai báo sự kiện nút sửa 
    function onSuaClick() {
      console.log("ấn nút sửa ");
      $("#update-voucher-modal").modal("show");  // hiện modal
      var vObject = readObjectRow(this);
      console.log("id là:  " + vObject.id);
      gId = vObject.id;
      // load toàn bộ thông tin người dùng lên modal
      // b1 b2 bỏ qua
      // b3 . gọi api lấy object  
      var vObjectDataUser = null;
      getDataByID(vObject.id, function (pamramRes) {
        // b4 xử lý hiển thị  đổ dữ liệu lên modal 
        console.log(pamramRes);
        loadDataInModalUpdateUser(pamramRes);
        return;
      });
    }
    // khai báo sự kiện nút xóa user
    function onXoaClick() {
      console.log("ấn nut xóa ");
      var vObject = readObjectRow(this);
      console.log("id là:  " + vObject.id);
      gId = vObject.id; // 
      $("#delete-confirm-modal").modal("show");  // hiện modal xóa 
    }
    // khai báo sự kiện nút thêm user
    function onAddUserClick() {
      console.log("ấn nut add user ");
      $("#insert-sinh-vien-modal").modal("show");  // hiện modal.
    }
    // khai báo nút insert user (add user);
    function onInsertUserClick() {
      console.log("ấn nút insert user ");
      //04 bước xử lý sự kiện có gọi server
      // b1 thu thâpj dữ liệu
      var vObject = readDataModalInsertUser();  // đọc dữ liệu trên form modal sửa thông tin người dùng
      // b2 validate data
      var vResult = validateDataUser(vObject);
      console.log("thuong", vObject);
      // b3 call server
      if (vResult) {
        $.ajax({
          type: "POST",
          url: gBASE_URL + "/grades",
          data: JSON.stringify(vObject),
          contentType: "application/json",
          success: function (data) {
            console.log("đã thêm điểm thành công");
            alert("đã thêm điểm thành công");
            $("#insert-sinh-vien-modal").modal("hide"); //tắt Modal 
            callApiListDiem(getInsertRowTable); //  load lại bảng danh sách users
          },
          error: function () {
            alert("quá trình thêm điểm gặp sự cố");
          }
        });
      }
      // b4
      console.log(vObject);
    }

    // khai baos nút xác nhận update  sửa user
    function onModalUpdateUserClick() {
      console.log("ấn nut xác nhận update  user ");
      //04 bước xử lý sự kiện có gọi server
      // b1 thu thâpj dữ liệu
      var vObject = readDataInModalUpdateUser();  // đọc dữ liệu trên form modal sửa thông tin người dùng
      // b2 validate data
      var vResult = validateDataUser(vObject);
      // b3 call server
      if (vResult) {
        alert("thông báo đã xử lý cập nhật vui lòng chờ phản hồi");
        updateUserById(vObject, function (pamramRes) {
          // b4 hiển thị font end 
          console.log("update: ", pamramRes);
          alert("thông báo đã cập nhật thành công");
          $("#update-voucher-modal").modal("hide"); //tắt Modal 
          callApiListDiem(getInsertRowTable); //  load lại bảng danh sách users

        });
      }
    }
    // nút xác nhận xóa user 
    function onConfirmDeleteUserClick() {
      console.log("Xác nhận xóa ");
      // b3 gọi api để xóa user theo iD 
      alert("thông báo đang  xóa user vui lòng đợi phản hồi");
      callApiDeleteUser(function () {
        // xử lý font end 
        alert("thông báo đã xóa user thành công");
        $("#delete-confirm-modal").modal("hide"); //tắt Modal 
        callApiListDiem(getInsertRowTable); //  load lại bảng danh sách users 
      });
    }
    //Lọc dữ liệu 
    function locDuLieu() {
      console.log("đã ấn nút lọc dữ liệu");
      // 4 bước xử lý dữ liệu 
      // b1 . đọc dữ liệu
      var vObject = getReadDataFiter();
      console.log("đối tượng sau khi đọc dữ liệu lọc", vObject);
      // bước 2 . kiểm tra bỏ qua 
      // bước 3 lọc 
      var vArrObject = getFilter(vObject);  // lọc nhiều phần tử 
      // bước 4 . xử lý font end 
      console.log("đối tượng sau khi Lọc dữ liệu lọc", vArrObject);
      getInsertRowTable(vArrObject);  // đổ dữ liệu đã lọc lên table
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //              XỬ LÝ PHẦN LỌC DỮ LIỆU  
    // bước 1 đọc dữ liệu trả về đối tượng chứa tên sinh viên và tên môn học 
    function getReadDataFiter() {
      var vObject = {
        monHoc: [],
        sinhVien: [],
      }
      // đọc tên sinh viên
      var vSinhVien = $(".select-sinh-vien").val();
      // đọc tên môn học 
      var vMonHoc = $(".select-mon-hoc").val();
      // gán 2 danh sách vào đối tượng 
      vObject.monHoc = vMonHoc;
      vObject.sinhVien = vSinhVien;
      return vObject;
    }
    // buoc 3 loc
    //input từ khóa tìm kiếm   paramFilterObj và danh sách điểm gDiem
    function getFilter(paramFilterObj) {
      "use strict"
      var gDiemNew = gDiem;
      callApiListDiem(function(paramRes){
        gDiem = paramRes;
      }); //  load lại bảng danh sách users
      // chia nhỏ bài toán thành từng phần cụ thể lọc từng phần tử .. 
      // cụ thể vSinh (lọc sinh viên trước ) sau đó  lọc vSinh viên với môn học
      // lọc nhiều sinh viên thì lọc 1 sinh viên sau đó ghép lại thành nhiều sinh viên
      //hàm thực hiện lọc và hiển thị lên table
      var vResult = []; // khai báo biến lưu trữ sau lọc .. lọc xong add vào vArrFilter
      var vResult2 = [];  //khai báo biến lưu trữ sau lọc .. lọc xong add vào vArrSinhVienAndMonHoc
      var vArrFilter = [];  // mảng chứa data sau khi lọc sinh viên
      var vArrSinhVienAndMonHoc = [];  // mảng chứa toàn bộ dữ liệu sau khi lọc
      //thực hiện lọc với gDiem
      for (var bI = 0; bI < paramFilterObj.sinhVien.length; bI++) {
        vResult = gDiemNew.filter(function (paramOrder) {
          return (paramFilterObj.sinhVien[bI] == 0 || paramOrder.studentId == paramFilterObj.sinhVien[bI]);
        });
        vArrFilter.push(...vResult);
      }
      //thực hiện lọc với vArrFilter
      for (var bI = 0; bI < paramFilterObj.monHoc.length; bI++) {
        vResult2 = vArrFilter.filter(function (paramOrder) {
          return (paramFilterObj.monHoc[bI] == 0 || paramOrder.subjectId == paramFilterObj.monHoc[bI]);
        });
        vArrSinhVienAndMonHoc.push(...vResult2);
      }
      console.log("vArrSinhVienAndMonHoc", vArrSinhVienAndMonHoc);
      return vArrSinhVienAndMonHoc;  // trả về giá trị cho hàm 
    }

    //            XỬ LÝ PHẦN ONPAGELOADING  
    // khởi tạo data table 
    function khoiTaoDataTable() {
      // khai báo mảng chứa giá trị các cột 
      const ARRAY_NAME_COL = ["stt", "studentId", "subjectId", "grade",
        "examDate", "action"];
      // định nghĩa số thứ tự cho các cột 
      const COL_STT = 0;
      const COL_SINH_VIEN = 1;
      const COL_MON_HOC = 2;
      const COL_DIEM = 3;
      const COL_NGAY_THI = 4;
      const COL_ACTION = 5;

      /* add JSON data vào DataTable sử dụng add trực tiếp DataTable row */
      $("#table-lich-su-hoc-tap").DataTable({
        paging: true,   // phân trang
        lengthChange: false,  // ố bản ghi / mỗi trang
        searching: false,  // tìm kiếm 
        ordering: true,    //sắp xếp
        columns: [
          { data: ARRAY_NAME_COL[COL_STT] },
          { data: ARRAY_NAME_COL[COL_SINH_VIEN] },
          { data: ARRAY_NAME_COL[COL_MON_HOC] },
          { data: ARRAY_NAME_COL[COL_DIEM] },
          { data: ARRAY_NAME_COL[COL_NGAY_THI] },
          { data: ARRAY_NAME_COL[COL_ACTION] },
        ],
        columnDefs: [

          {
            targets: COL_STT, // cột age  gListMonHoc  
            render: function () {
              gStt++;
              return gStt;
            }
          },
          {
            targets: COL_SINH_VIEN, // cột sinh viên  
            render: renderIdByName,
          },
          {
            targets: COL_MON_HOC, // cột sinh viên  
            render: renderIdByNameSubject,
          },
          {
            targets: COL_ACTION,
            defaultContent: '<i style="cursor: -webkit-grab; cursor: grab;" class="fa-solid fa-pencil   btn-edits" data-toggle="tooltip" data-placement="top" title="Sửa"></i>  &nbsp; &nbsp;' +
              '<i  style="cursor: -webkit-grab; cursor: grab;" class="fa-regular fa-trash-can btn-deletes" data-toggle="tooltip" data-placement="top" title="Xóa"></i>',
          },
        ]
      });
    }
    //  gọi API load all users    
    function callApiListDiem(pramFunction) {
      // khai báo ajax jquery
      $.ajax({
        url: gBASE_URL + "/grades",
        type: "GET",
        dataType: "json",
        success: pramFunction,
        error: function (paramError) {
          console.log("lỗi khi gọi api All user" + paramError.status);
        }
      });
    }
    // hàm thêm từng dòng dữ liệu vào   // hàm này chính là success
    function getInsertRowTable(paramRes) {
      console.log("đã load đến insert table");
      var vTable = $("#table-lich-su-hoc-tap").DataTable();
      vTable.clear();// xóa trắng tbody trước khi load dữ liệu  
      vTable.rows.add(paramRes);
      vTable.draw();
      gStt = 0; // quy 0 số thứ tự
      gDiem = paramRes;
      // đổ dữ liệu table xongg đổ dữ liệu lên modal

    }
    // chuyểb id  sinh viên thành tên sinh viên
    function renderIdByName(paramData, paramType, paramRow) {
      // các dòng dưới in ra để hiểu các thuộc tính
      // console.log(paramData); // mỗi ô đang render
      // console.log(paramRow);  // cả hàng 
      // console.log("type = " + paramType); //type có thể là display (dữ liệu hiện thị), filter (dữ liệu khi lọc), sort (dữ liệu khi sắp xếp); TRONG BÀI NÀY, ta trả vè giống nhau
      var vArrRole = gListHocSinh;
      var vResultRole = "";                         // 
      var vDieuKien = false;
      var vViTriHienTai = 0;
      while (!vDieuKien && vViTriHienTai < vArrRole.length) {
        // nếu tìm thấy thì vDieuKien = true;
        //tăng 1 đơn vị khi lăp qua 
        if (vArrRole[vViTriHienTai].id == paramData) {
          vDieuKien = true;  //  đổi trạng thái để dừng vòng lặp 
          vResultRole = vArrRole[vViTriHienTai].firstname + " " + vArrRole[vViTriHienTai].lastname;   // gán kết quả trả về là role name theo id
          return vResultRole;   // trả về giá trị 
        }
        vViTriHienTai++;   // tăng giá trị lên 1 đơn vị 
      }
    }

    // render id môn học thành tên môn học 
    function renderIdByNameSubject(paramData, paramType, paramRow) {
      // các dòng dưới in ra để hiểu các thuộc tính
      // console.log(paramData); // mỗi ô đang render
      // console.log(paramRow);  // cả hàng 
      // console.log("type = " + paramType); //type có thể là display (dữ liệu hiện thị), filter (dữ liệu khi lọc), sort (dữ liệu khi sắp xếp); TRONG BÀI NÀY, ta trả vè giống nhau
      var vArrRole = gListMonHoc;
      var vResultRole = "";                         // 
      var vDieuKien = false;
      var vViTriHienTai = 0;
      while (!vDieuKien && vViTriHienTai < vArrRole.length) {
        // nếu tìm thấy thì vDieuKien = true;
        //tăng 1 đơn vị khi lăp qua 
        if (vArrRole[vViTriHienTai].id == paramData) {
          vDieuKien = true;  //  đổi trạng thái để dừng vòng lặp 
          vResultRole = vArrRole[vViTriHienTai].subjectName;   // gán kết quả trả về là role name theo id
          return vResultRole;   // trả về giá trị 
        }
        vViTriHienTai++;   // tăng giá trị lên 1 đơn vị 
      }
    }

    // lấy tất cả giá trị của 1 hàng tương ứng với nút bấm trên hàng đó 
    function readObjectRow(paramThis) {
      console.log(paramThis);
      var vRowClick = $(paramThis).closest("tr"); // xác định hàng của nút ấn trên table  nut ấn 
      var vTable = $("#table-lich-su-hoc-tap").DataTable();   // tạo biến đến dataTable 
      var vDataRow = vTable.row(vRowClick);  // tìm hàng này trên data table trên data table 
      return vDataRow.data();
    }
    // ........................ [nút insert user in modal].......................
    //04 bước xử lý sự kiện có gọi server
    // b1 thu thâpj dữ liệu và trả về object chứa thông tin người dùng 
    function readDataModalInsertUser() {
      var vObjectUser = {
        studentId: "",
        subjectId: "",
        grade: "",
        examDate: "",
      }
      // gán giá trị cho đối tượng 
      vObjectUser.studentId = $("#inp-modal-sinh-vien-them").val().trim();
      vObjectUser.subjectId = $("#inp-modal-mon-hoc-them").val().trim();
      vObjectUser.grade = $("#inp-modal-diem-them").val().trim();
      vObjectUser.examDate = $("#inp-modal-ngay-thi-them").val();
      return vObjectUser;
    }
    // b2 validate data
    // kiểm tra xem người dùng có nhập hay k . nếu không nhập thì nhắc nhở người dùng
    function validateDataInsertUser(paramObject) {
      if (paramObject.studentId === "") {
        alert("Sinh  phải được chọn ");
        return false;
      }
      if (paramObject.subjectId === "") {
        alert("last name không được để trống ");
        return false;
      }
      if (paramObject.grade === "") {
        alert("subject không được để trống ");
        return false;
      }
      if (paramObject.examDate === "") {
        alert("country không được để trống ");
        return false;
      }
      return true;
    }


    // b4 hiển thị font end
    function successInsertData(pamramRes) {
      alert("Thêm voucher thành công Id của bạn là  " + pamramRes.id);
      callApiListDiem(getInsertRowTable);
      resertCreateVoucherForm(); // xóa trắng dữ liệu 
      $("#user-insert-modal").modal("hide");  // ẩn modal
    }

    // hàm xóa trắng form create voucher
    function resertCreateVoucherForm() {
      $("#input-modal-firstname").val("");
      $("#input-modal-lastname").val("");
      $("#input-modal-subject").val("");
      $("#input-modal-country").val("");
      $("#input-modal-customer-type").val("");
    }
    // ......................[ xử lý nút edit . nút sửa ].....................
    // Mẫu gọi API Get User by id
    function getDataByID(paramId, paramFunction) {
      $.ajax({
        url: gBASE_URL + "/grades/" + paramId,
        type: "GET",
        dataType: "json",
        success: paramFunction,
        error: function (paramError) {
          console.log(paramError.status)
        },
      });
    }
    //load load dữ liệu lên fomr modal update
    function loadDataInModalUpdateUser(paramObject) {
      // đổi từ id 
      $("#inp-modal-sinh-vien").val(paramObject.studentId);
      $("#inp-modal-mon-hoc").val(paramObject.subjectId);
      $("#inp-modal-diem").val(paramObject.grade);
      $("#inp-modal-ngay-thi").val(paramObject.examDate);

    }
    // ..................................[Nút update user (sửa thông tin người dùng)].............
    //04 bước xử lý sự kiện có gọi server
    // b1 thu thâpj dữ liệu
    function readDataInModalUpdateUser() {
      var vObjectUser = {
        studentId: "",
        subjectId: "",
        grade: "",
        examDate: "",

      }
      // gán giá trị cho đối tượng 
      vObjectUser.studentId = $("#inp-modal-sinh-vien").val().trim();
      vObjectUser.subjectId = $("#inp-modal-mon-hoc").val().trim();
      vObjectUser.grade = $("#inp-modal-diem").val().trim();
      vObjectUser.examDate = $("#inp-modal-ngay-thi").val();

      return vObjectUser;
    }
    // b2 validate data
    function validateDataUser(paramObject) {
      if (paramObject.studentId === "0") {
        alert("tên sinh viên phải được chọn ");
        return false;
      }
      if (paramObject.subjectId === "0") {
        alert("tên môn phải được chọn ");
        return false;
      }
      if (paramObject.grade === "" || paramObject.grade > 10 || paramObject.grade < 0) {
        alert("điểm  không được để trống và phải là số nguyên từ 0 đến 10 ");
        return false;
      }
      if (paramObject.examDate === "") {
        alert("ngày tháng không được bỏ trống phải được chọn ");
        return false;
      }

      return true;
    }

    // b3 call server
    //  gọi API Update user by Id
    function updateUserById(paramObject, paramFunction) {
      $.ajax({
        url: gBASE_URL + "/grades/" + gId,
        type: "PUT",
        contentType: "application/json;charset=UTF-8",
        data: JSON.stringify(paramObject),
        success: paramFunction,
        error: function (paramError) {
          console.log(paramError.status);
          alert("thông báo đã cập nhật không thành công");

        }
      });
    }
    // ................... [nút xác nhận xóa User]............
    function callApiDeleteUser(paramFunciton) {
      $.ajax({
        url: gBASE_URL + "/grades/" + gId,
        type: "DELETE",
        dataType: "json",
        success: paramFunciton,
        error: function (paramError) {
          console.log(paramError.status);
          alert("Hệ thống chưa thể xóa User do trục trặc kỹ thuật ");
          $("#delete-confirm-modal").modal("hide"); //tắt Modal 
        },
      });
    }

    // gọi sever để lấy danh sách học sinh,   sau đó gắn vào biến toàn cục ;
    function callDanhSachHocSinh() {
      $.ajax({
        type: "GET",
        url: gBASE_URL + "/students",
        dataType: "json",
        success: function (paramRes) {
          console.log("data hoc sinh tra ve", paramRes);
          gListHocSinh = paramRes;
          // thực hiện đổ data lên thẻ select 
          getDoDuLieuLenSelectHocSinh(paramRes);
        },
        error: function (error) {
          console.log(error.status);
        }
      });
    }
    // gọi sever để lấy danh sách học sinh,   sau đó gắn vào biến toàn cục ;
    function callDanhSachMonHoc(paramFunction) {
      $.ajax({
        type: "GET",
        url: gBASE_URL + "/subjects",
        dataType: "json",
        success: function (paramRes) {
          console.log("data môn học  tra ve", paramRes);
          gListMonHoc = paramRes;
          getDoDuLieuLenSelectMonHoc(paramRes);
        },
        error: function (error) {
          console.log(error.status);
        }
      });
    }

    // đổ data lên thẻ select 
    function getDoDuLieuLenSelectMonHoc(paramRes) {
      console.log("dang đổ dữ liệu lên ô select");
      //
      var vSelect = $(".select-mon-hoc");
      for (var i = 0; i < paramRes.length; i++) {
        var vRowData = paramRes[i];
        $("<option>").val(
          vRowData.id
        ).html(vRowData.subjectName).appendTo(vSelect);
      }
    }

    // đổ data lên thẻ select học sinh
    function getDoDuLieuLenSelectHocSinh(paramRes) {
      console.log("dang đổ dữ liệu lên ô select");
      //
      var vSelect = $(".select-sinh-vien");
      for (var i = 0; i < paramRes.length; i++) {
        var vRowData = paramRes[i];
        $("<option>").val(
          vRowData.id
        ).html(vRowData.firstname + " " + vRowData.lastname).appendTo(vSelect);
      }
    }

  </script>
</body>

</html>